#!/usr/bin/make -f
# Makefile for Cadence #
# ---------------------- #
# Created by falkTX
#

# Build Type (native or wine)
BUILD = native

CXX ?= g++
WINECXX ?= wineg++

BASE_FLAGS = -O2 -Wall -fPIC -ffast-math -fomit-frame-pointer -mtune=generic -msse $(CXXFLAGS) -I. -ldl -lrt -lpthread `pkg-config --cflags --libs liblo` $(LDFLAGS)

BRIDGE_LV2_X11_FLAGS  = $(BASE_FLAGS) -DBRIDGE_LV2_X11 `pkg-config --cflags --libs QtCore QtGui`
BRIDGE_LV2_GTK2_FLAGS = $(BASE_FLAGS) -DBRIDGE_LV2_GTK2 `pkg-config --cflags --libs gtk+-2.0`
BRIDGE_LV2_QT4_FLAGS  = $(BASE_FLAGS) -DBRIDGE_LV2_QT4 `pkg-config --cflags --libs QtCore QtGui`
BRIDGE_VST_QT4_FLAGS  = $(BASE_FLAGS) -DBRIDGE_VST_QT4 `pkg-config --cflags --libs QtCore QtGui` -Ivestige
BRIDGE_WINVST_FLAGS   = $(BASE_FLAGS) -DBRIDGE_WINVST `pkg-config --cflags --libs jack QtCore` -L/usr/lib32 -L/usr/lib/i386-linux-gnu -Ivestige -m32 -DDEBUG=1
BRIDGE_WINVST_FLAGS  += -DNDEBUG -DQT_NO_DEBUG -DQT_NO_DEBUG_STREAM -DQT_NO_DEBUG_OUTPUT
# BRIDGE_WINVST_FLAGS  += -DDEBUG -O0 -g

all: build

native:
	$(MAKE) BUILD=native

wine:
	$(MAKE) BUILD=wine

# TODO
native32: native
native64: native
wine32:
wine64:

ifeq ($(BUILD),native)
build: carla-bridge-lv2-x11 carla-bridge-lv2-gtk2 carla-bridge-lv2-qt4 carla-bridge-vst-qt4
else ifeq ($(BUILD),wine)
build: carla-bridge-winvst.exe
else
build:
endif

carla-bridge-lv2-x11: carla-bridge-lv2.cpp carla-bridge-x11.cpp osc.cpp carla-bridge.h bridge-includes.h osc.h
	$(CXX) carla-bridge-lv2.cpp carla-bridge-x11.cpp osc.cpp $(BRIDGE_LV2_X11_FLAGS) -o $@

carla-bridge-lv2-gtk2: carla-bridge-lv2.cpp carla-bridge-gtk2.cpp osc.cpp carla-bridge.h bridge-includes.h osc.h
	$(CXX) carla-bridge-lv2.cpp carla-bridge-gtk2.cpp osc.cpp $(BRIDGE_LV2_GTK2_FLAGS) -o $@

carla-bridge-lv2-qt4: carla-bridge-lv2.cpp carla-bridge-qt4.cpp osc.cpp carla-bridge.h bridge-includes.h osc.h
	$(CXX) carla-bridge-lv2.cpp carla-bridge-qt4.cpp osc.cpp $(BRIDGE_LV2_QT4_FLAGS) -o $@

carla-bridge-vst-qt4: carla-bridge-vst.cpp carla-bridge-qt4.cpp osc.cpp carla-bridge.h bridge-includes.h osc.h
	$(CXX) carla-bridge-vst.cpp carla-bridge-qt4.cpp osc.cpp $(BRIDGE_VST_QT4_FLAGS) -o $@

carla-bridge-winvst.exe: carla-bridge-winvst.cpp osc.cpp carla-bridge.h carla-bridge-plugin.h bridge-includes.h osc.h ../carla/vst_shared.h
	$(WINECXX) carla-bridge-winvst.cpp osc.cpp $(BRIDGE_WINVST_FLAGS) -o $@

clean:
	rm -f carla-bridge-lv2-x11 carla-bridge-lv2-gtk2 carla-bridge-lv2-qt4 carla-bridge-vst-qt4 carla-bridge-winvst.exe carla-bridge-winvst.exe.so
